#ifndef NUPLE_H
#define NUPLE_H

#include <vector>

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Interface of NUple
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
template <unsigned int s>
class NUple
{
public:
  operator const int*() const;
  unsigned int size() const;
  int operator[](unsigned int n) const;
  int& operator[](unsigned int n);
  template <unsigned int t>
  friend bool operator==(const NUple<t>& n0,const NUple<t>& n1);
  template <unsigned int t>
  friend bool operator<(const NUple<t>& n0,const NUple<t>& n1);
protected:
  int data_[s];
};
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Interface of Pair
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class Pair : public NUple<2>
{
public:
  Pair(unsigned int a,unsigned int b);
};
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Interface of Pair
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class Triplet : public NUple<3>
{
public:
  Triplet(unsigned int a,unsigned int b,unsigned int c);
};
//************************************************************
// Implementation of NUple
//************************************************************
template <unsigned int s>
NUple<s>::operator const int*() const
{
  return data_;
}
template <unsigned int s>
unsigned int
NUple<s>::size() const
{
  return s;
}
template <unsigned int s>
int
NUple<s>::operator[](unsigned int n) const
{
  return data_[n];
}
template <unsigned int s>
int&
NUple<s>::operator[](unsigned int n)
{
  return data_[n];
}
template <unsigned int s>
bool
operator==(const NUple<s>& n0,const NUple<s>& n1)
{
  for (unsigned int i=0;i<s;++i)
  {
    if (n0.data_[i] != n1.data_[i]) return false;
  }
  return true;
}
template <unsigned int s>
bool
operator<(const NUple<s>& n0,const NUple<s>& n1)
{
  for (unsigned int i=0;i<s;++i)
  {
    if (n0.data_[i] < n1.data_[i]) return true;
    if (n0.data_[i] > n1.data_[i]) return false;
  }
  return false;
}

#endif // NUPLE_H
